//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>
#pragma hdrstop

#include "transfer.h"
#include "dtucfgheader.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    EditPort->Text = "51236";

    m_hServer = 0;
    m_hDTU = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnStartSerClick(TObject *Sender)
{
    if(m_hServer == 0)
    {
        m_hServer = DTU_AddNetServer("", StrToInt(EditPort->Text), "");
        if(DTU_Init(m_hServer) == 0)
        {
            DTU_Delete(m_hServer);
            m_hServer = 0;
            ShowMessage("޷");
            return;
        }
        BtnStartSer->Caption = "ֹͣ";
        Timer100->Enabled = true;
    }
    else
    {
        if(m_hDTU != 0)
        {
            DTU_Uninit(m_hDTU);
            DTU_Delete(m_hDTU);
            m_hDTU = 0;
        }
        DTU_Uninit(m_hServer);
        DTU_Delete(m_hServer);
        m_hServer = 0;
        Timer100->Enabled = false;
        BtnStartSer->Caption = "";
	ListClient->Items->Clear();
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer100Timer(TObject *Sender)
{
    if(m_hServer != 0)
    {
        HANDLE hClient;
        hClient = DTU_GetNewConnectedClient(m_hServer);
        TListItem *ListItem;

        if(hClient != 0)
        {
            char szdesip[20], sztype[20], szname[30], szid[20], szphone[20];
            int port;
            DTU_GetClientInfo(hClient, szdesip, &port, sztype, szname, szid, szphone);

            ListItem = ListClient->Items->Add();
            ListItem->Caption = szdesip;
            ListItem->SubItems->Add(IntToStr(port));
            ListItem->Data = hClient;
        }

        // for(int i = 0; i < ListClient->Items->Count; i ++)
        for ( int i = ListClient->Items->Count - 1; i >= 0; i-- )
        {
            ListItem = ListClient->Items->Item[i];
            m_hDTU = ListItem->Data;
            if(DTU_IsClientAvailable(m_hDTU))
            {
                int length = DTU_GetReceiveDataCount(m_hDTU);
                if(length != 0)
                {
                    char *buf = new char[length];

                    DTU_ReceiveData(m_hDTU, buf, length);
                    MemoRec->Text = MemoRec->Text + buf;

                    delete [] buf;
                }
            }
            else
            {
                DTU_Uninit(m_hDTU);
                DTU_Delete(m_hDTU);
                m_hDTU = 0;
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnClrRecClick(TObject *Sender)
{
    MemoRec->Text = "";    
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BtnClrSentClick(TObject *Sender)
{
    MemoSend->Text = "";
}
//---------------------------------------------------------------------------
int strHexToInt(char* strSource)
{
	assert(strSource);
    int nDecNum;
    int nTemp = 0;
    int iLength = (int)::strlen(strSource);
    for(int i = 0;  i < iLength;  i++)
	{
		switch(strSource[i])
		{
			case 'a':
			case 'A':	nDecNum = 10;	break;
			case 'b':
			case 'B':	nDecNum = 11;	break;
			case 'c':
			case 'C':   nDecNum = 12;   break;
			case 'd':
			case 'D':   nDecNum = 13;   break;
			case 'e':
			case 'E':   nDecNum = 14;   break;
			case 'f':
			case 'F':   nDecNum = 15;   break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':    nDecNum = strSource[i] - '0';     break;
			default:     return -1;
        }
	    nTemp += nDecNum * (int)::pow(16, iLength - i - 1);
	}
	return nTemp;
}


void StrFromHex (AnsiString &str)
{
    assert(!str.IsEmpty());

    if(str.IsEmpty())
    {
        return ;
    }

    int iLength = str.Length();
    char *buf = new char[iLength];
    char buff[3];

    strcpy(buf, str.c_str());
    str.Delete(1, iLength);

    char temp[2];
    for(int i = 0; i < iLength + 1; i++)
    {
        if(buf[i] == 0x20 || buf[i] == 0x0d || buf[i] == 0x0a) // ո
        {
            continue;
        }

        buff[0] = buf[i++];
        buff[1] = buf[i];
        buff[2] = '\0';

        int itemp = strHexToInt(buff);

        if(-1 == itemp)
        {
            str.Delete(1, iLength);
            break;
        }

        sprintf(temp, "%c", itemp);

        str += temp;
    }
    delete [] buf;
}

void __fastcall TForm1::BtnSendClick(TObject *Sender)
{
    if(m_hServer != 0)
    {
        TListItem *ListItem;
        ListItem = ListClient->Selected;
        if(ListItem == 0)
        {
            ShowMessage("ûпͻ");
            return;
        }

        m_hDTU = ListItem->Data;
        if(DTU_IsClientAvailable(m_hDTU))
        {
            AnsiString s = MemoSend->Text;
            if(RadioHex->Checked == true)
            {
                StrFromHex(s);
            }
            int length = s.Length();
            if(length == 0)
            {
                return;
            }
            DTU_SendData(m_hDTU, (unsigned char*)s.c_str(), length);
        }
    }
    else
    {
        ShowMessage("˿û");
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    if(m_hServer != 0)
    {
        if(m_hDTU != 0)
        {
            DTU_Uninit(m_hDTU);
            DTU_Delete(m_hDTU);
            m_hDTU = 0;
        }
        DTU_Uninit(m_hServer);
        DTU_Delete(m_hServer);
        m_hServer = 0;
    }
    ListClient->Clear();
    Timer100->Enabled = false;
}
//---------------------------------------------------------------------------

