unit transfer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, StrUtils, DTUSet;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    EditPort: TEdit;
    BtnServer: TButton;
    ListClient: TListView;
    Label2: TLabel;
    MemoRec: TMemo;
    BtnClrRec: TButton;
    MemoSend: TMemo;
    Label3: TLabel;
    RadioDec: TRadioButton;
    RadioHex: TRadioButton;
    BtnClrSend: TButton;
    BtnSend: TButton;
    Timer100: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure BtnServerClick(Sender: TObject);
    procedure BtnClrRecClick(Sender: TObject);
    procedure BtnClrSendClick(Sender: TObject);
    procedure Timer100Timer(Sender: TObject);
    procedure BtnSendClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    procedure TransToDec (Var str : string);
  public
    { Public declarations }
    hCurSlave : integer;
    m_hServer : integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
    NewColumn : TListColumn;
    hCurSlave : integer;
begin
    m_hServer := 0;

    Timer100.Enabled := False;

    EditPort.Text := '51236';

    ListClient.ViewStyle := vsReport;

    NewColumn := ListClient.Columns.Add();
    NewColumn.Width := 120;
    NewColumn.Caption := 'IP';
    NewColumn := ListClient.Columns.Add();
    NewColumn.Width := 45;
    NewColumn.Caption := '˿';
    NewColumn := ListClient.Columns.Add();
    NewColumn.Width := 55;
    NewColumn.Caption := '';
end;


procedure TForm1.BtnServerClick(Sender: TObject);
begin
    If m_hServer = 0 Then
    begin
        m_hServer := DTU_AddNetServer('', StrToInt(EditPort.Text), '');
        if DTU_Init(m_hServer) = 0 then
        begin
            DTU_Uninit(m_hServer);
            DTU_Delete(m_hServer);
            m_hServer := 0;
            ShowMessage('޷˿ڷ');
            BtnServer.Caption := '';
            Timer100.Enabled := false;
            exit;
        end;
        BtnServer.Caption := 'ֹͣ';
        Timer100.Enabled := True;
    end
    else
    begin
        DTU_Uninit(m_hServer);
        DTU_Delete(m_hServer);
        m_hServer := 0;

        BtnServer.Caption := '';
        Timer100.Enabled := False;
        ListClient.Clear();
    end;
end;

procedure TForm1.BtnClrRecClick(Sender: TObject);
begin
    MemoRec.Text := '';
end;

procedure TForm1.BtnClrSendClick(Sender: TObject);
begin
    MemoSend.Text := '';
end;

procedure TForm1.Timer100Timer(Sender: TObject);
var
    szIP : array[0..20] of char;
    szType : array[0..20] of char;   
    szName : array[0..20] of char;
    szID : array[0..20] of char;
    szPhone : array[0..20] of char;
    desPort : integer;

    ListItem : TListItem;

    i : integer;
    count : integer;
    length : integer;
    buf : array of char;
    hCurSlave : integer;

    strName : string[20];
begin
    if m_hServer <> 0 then
    begin
        hCurSlave := DTU_GetNewConnectedClient(m_hServer);
        if hCurSlave <> 0 then
        begin
            DTU_GetClientInfo(hCurSlave, @szIP[0], @desPort, @szType[0], @szName[0], @szID[0], @szPhone[0]);

            ListItem := ListClient.Items.Add;
            ListItem.Caption := szIP;
            ListItem.SubItems.Add(IntToStr(desPort));
            ListItem.SubItems.Add(IntToStr(hCurSlave));

            for i := 1 to 20 do
                strName[i] := szName[i];

            // ListItem.SubItems.Add(strName);
        end;
    end;

    count := ListClient.Items.Count;
    i := count - 1;
    while i >= 0 do
    Begin
        hCurSlave := StrToInt(ListClient.Items[i].SubItems[1]);

        if DTU_IsClientAvailable(hCurSlave) = 1 then
        begin
            length := DTU_GetReceiveDataCount(hCurSlave);
            if length <> 0 then
            begin
                SetLength(buf, length);
                DTU_ReceiveData(hCurSlave, @buf[0], length);
                MemoRec.Text := MemoRec.Text + String(buf);
            end;
        end
        else
        begin
            DTU_Uninit(hCurSlave);
            DTU_Delete(hCurSlave);

            // ɾһ
            ListClient.Items.Item[i].Delete;

            hCurSlave := 0;
        end;
        i := i - 1;
    end;
end;

procedure TForm1.TransToDec (Var str : string);
var
    buf : string;
    temp : string;
    i : integer;
begin
    Assert((@str <> nil), 'input nil');
    temp := str;
    str := '';
    buf := '';
    while Length(temp) > 1 do
    begin
        buf := AnsiLeftStr(temp, 2);
        if Length(temp) > 2 then
        begin
            temp := AnsiRightStr(temp, Length(temp) -3);
        end
        else
            temp := AnsiRightStr(temp, (Length(temp) - 2));

        i := StrToInt('$' + string(buf));
        str := str + Chr(i);
    end;
end;

procedure TForm1.BtnSendClick(Sender: TObject);
var
    ListItem : TListItem;
    s : string;
    hCurSlave : integer;
begin
    if m_hServer = 0 then
    begin
        ShowMessage('ûп');
        Exit;
    end;
    ListItem := ListClient.ItemFocused;
    if ListItem = nil then
    begin
        ShowMessage('ûпͻ');
        Exit;
    end;

    hCurSlave := StrToInt(ListItem.SubItems[1]);
    if DTU_IsClientAvailable(hCurSlave) = 1 then
    begin
        s := MemoSend.Text;
        if Length(s) = 0 then
            Exit;

        if RadioHex.Checked = True then
            TransToDec(s);

        DTU_SendData(hCurSlave, PByte(s), Length(s));
    end
    else
    begin
        DTU_Uninit(hCurSlave);
        DTU_Delete(hCurSlave);   

        // ɾǰѡе豸Ϊڷʧ
        ListItem.Delete;

        hCurSlave := 0;
        ShowMessage('ͻЧ');
    end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    if m_hServer <> 0 then
    begin
        DTU_Uninit(m_hServer);
        DTU_Delete(m_hServer);
        m_hServer := 0;

        ListClient.Clear();
        Timer100.Enabled := False;
    end;
end;

end.
