﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace LocalConfigure
{
    public partial class Form1 : Form
    {
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_AddCOM(Int32 comindex,Int32 baud,Int32 databits,Int32 checkbits,Int32 stopbits);

        //用于远程配置
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_AddNetServer([MarshalAs(UnmanagedType.LPStr)] string szip,
            Int32 localport,[MarshalAs(UnmanagedType.LPStr)] string szpwd);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_GetNewConnectedClient(Int32 hServerDTU);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_GetClientInfo(Int32 hServerDTU,
            ref byte pszdesip,ref Int32 pdesport,ref byte sztype,ref byte szname,ref byte szid,ref byte szphone);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_IsClientAvailable(Int32 hServerDTU);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_SendData(Int32 hServerDTU,ref byte pdata,Int32 len);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_ReceiveData(Int32 hServerDTU,ref byte pdata,Int32 len);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_GetReceiveDataCount(Int32 hServerDTU);

        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_GetAllConfig(Int32 hServerDTU);//用于一次性获取所有配置信息，和DTU_GetConfig一起配合使用
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_GetConfig(Int32 hServerDTU, ref byte szcmd,
            ref byte szdata);

        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_Init(Int32 hServerDTU);//必须在主线程中调用

        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_EnterConfig(Int32 hServerDTU);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_ConfigRead(Int32 hServerDTU,[MarshalAs(UnmanagedType.LPStr)] string szcmd,
            ref byte szdata);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_ConfigWrite(Int32 hServerDTU,[MarshalAs(UnmanagedType.LPStr)] string szcmd,
            [MarshalAs(UnmanagedType.LPStr)] string szdata);
        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_ExitConfig(Int32 hServerDTU,Int32 wait);

        [DllImport("DTUSet.dll")]
        static extern Int32 DTU_Uninit(Int32 hServerDTU);//必须在主线程中调用

        [DllImport("DTUSet.dll")]
        static extern void DTU_Delete(Int32 hServerDTU);


        public Form1()
        {
            InitializeComponent();
        }

        private Int32 m_hDTU=0;
        private byte m_bEnterConfig=0;

        private void SetBtnState(byte started)
        {
            if(started==1)
                button_Enter.Enabled=false;
            else
                button_Enter.Enabled=true;
            m_bEnterConfig=started;
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox_COM.SelectedIndex=0;
            comboBox_DataB.SelectedIndex = 3;
            comboBox_Parity.SelectedIndex=0;
            comboBox_Baud.SelectedIndex=9;
            
            comboBox_StopB.SelectedIndex=0;
            comboBox_Mode.SelectedIndex=0;
            comboBox_COMBaud.SelectedIndex=9;
            comboBox_COMDataB.SelectedIndex=3;
            comboBox_COMStopB.SelectedIndex=0;
            comboBox_COMParity.SelectedIndex=0;
            
            m_hDTU = 0;
            SetBtnState(0);
        }

        private void Addcom()
        {
            if(m_hDTU !=0)
            {
                DTU_Delete(m_hDTU);
                m_hDTU = 0;
            }
            int comind = comboBox_COM.SelectedIndex + 1;
            String str1=comboBox_Baud.SelectedItem.ToString();
            int baud = System.Convert.ToInt32(str1);
            str1 = comboBox_DataB.SelectedItem.ToString();
            int databits = System.Convert.ToInt32(str1);
            str1=comboBox_StopB.SelectedItem.ToString();
            int stopbits = System.Convert.ToInt32(str1);
            int checkbits = comboBox_Parity.SelectedIndex;
            m_hDTU = DTU_AddCOM(comind, baud, databits, checkbits, stopbits);
        }

        private void button_Enter_Click(object sender, EventArgs e)
        {
            Addcom();
            int res = DTU_Init(m_hDTU);
            if (res != 1 || DTU_EnterConfig(m_hDTU) != 1)
            {
                DTU_Delete(m_hDTU);
                m_hDTU=0;
                if(res==0)
                    MessageBox.Show("无法打开串口", "错误",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                else
                    MessageBox.Show("无法连接设备", "错误",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            m_bEnterConfig = 1;
            SetBtnState(m_bEnterConfig);
        }

        private void button_Exit_Click(object sender, EventArgs e)
        {
            int predtu = m_hDTU;
            if(m_hDTU==0)
                Addcom();

            if(predtu == 0 &&DTU_Init(m_hDTU) !=1)
            {
                DTU_Delete (m_hDTU);
                m_hDTU=0;
                MessageBox.Show("无法连接设备", "错误",
                      MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                m_bEnterConfig = 0;
                SetBtnState (m_bEnterConfig);
                return;
            }

            if(DTU_ExitConfig(m_hDTU, 1) != 1)
                 MessageBox.Show("操作失败", "错误",
                      MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            m_bEnterConfig = 0;
            SetBtnState (m_bEnterConfig);
            DTU_Delete (m_hDTU);
            m_hDTU = 0;
        }

        private int IsInCfg()
        {
            if(m_bEnterConfig == 0)
                MessageBox.Show("请先进入配置状态", "错误",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            return m_bEnterConfig;
        }
        private void button_GetInfo_Click(object sender, EventArgs e)
        {
            if(IsInCfg() == 0)
                return;

            if(DTU_GetAllConfig(m_hDTU) != 1)
            {
                MessageBox.Show("获取信息失败", "错误",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            byte[] szcmd = new byte[20];
            byte[] szdata = new byte[100];

            string strcmd = "";

            while (DTU_GetConfig(m_hDTU, ref szcmd[0], ref szdata[0]) == 1)
            {
                strcmd = convertBytesToString(ref szcmd);

                if (strcmd == "DTUID")
                {
                    textBox_ID.Text = convertBytesToString(ref szdata);

                }
                else if (strcmd == "PHON")
                {
                    textBox_Phone.Text = convertBytesToString(ref szdata);

                }
                else if (strcmd == "MODE")
                {
                    comboBox_Mode.Text = convertBytesToString(ref szdata);

                }
                else if (strcmd == "SERBAUD")
                {
                    comboBox_COMBaud.Text = convertBytesToString(ref szdata);

                }
                else if (strcmd == "SERDAT")
                {
                    comboBox_COMDataB.Text = convertBytesToString(ref szdata);

                }
                else if (strcmd == "SERSTP")
                {
                    comboBox_COMStopB.Text = convertBytesToString(ref szdata);

                }
                else if (strcmd == "SERCHK")
                {
                    comboBox_COMParity.Text = convertBytesToString(ref szdata);
                }
            }


            //byte[] szdata=new byte[100];



            //DTU_GetConfig(m_hDTU,"DTUID",ref szdata[0]);
            //textBox_ID.Text = System.Text.Encoding.ASCII.GetString(szdata);
            //DTU_GetConfig(m_hDTU, "PHON", ref szdata[0]);
            //textBox_Phone.Text = System.Text.Encoding.ASCII.GetString(szdata);
            //DTU_GetConfig(m_hDTU, "MODE", ref szdata[0]);
            //comboBox_Mode.Text = System.Text.Encoding.ASCII.GetString(szdata);
            //DTU_GetConfig(m_hDTU, "SERBAUD", ref szdata[0]);
            //comboBox_COMBaud.Text = System.Text.Encoding.ASCII.GetString(szdata);
            //DTU_GetConfig(m_hDTU, "SERDAT", ref szdata[0]);
            //comboBox_COMDataB.Text = System.Text.Encoding.ASCII.GetString(szdata);
            //DTU_GetConfig(m_hDTU, "SERSTP", ref szdata[0]);
            //comboBox_COMStopB.Text = System.Text.Encoding.ASCII.GetString(szdata);
            //DTU_GetConfig(m_hDTU, "SERCHK", ref szdata[0]);
            //comboBox_COMParity.SelectedIndex = System.Convert.ToInt32(
            //    System.Text.Encoding.ASCII.GetString(szdata));
        }

        private string convertBytesToString( ref byte[] szcmd )
        {
            string strcmd = "";
            for (int i = 0; i < szcmd.Length; i++ )
            {
                if ( szcmd[i] == 0 ) {
                    break;
                }
                strcmd += Convert.ToChar(szcmd[i]);
            }
	        return strcmd;
        }

        private void button_ModifyID_Click(object sender, EventArgs e)
        {
            if(IsInCfg() == 0)
                return;
            if(DTU_ConfigWrite(m_hDTU, "DTUID", textBox_ID.Text) !=1)
                   MessageBox.Show("更改失败", "错误",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void button_ModifyPhone_Click(object sender, EventArgs e)
        {
            if(IsInCfg() == 0)
                return;
            if (DTU_ConfigWrite(m_hDTU, "PHON", textBox_Phone.Text) != 1)
                   MessageBox.Show("更改失败", "错误",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void button_ModifyMode_Click(object sender, EventArgs e)
        {
            if (IsInCfg() == 0)
                return;
            if (DTU_ConfigWrite(m_hDTU, "MODE", comboBox_Mode.Text) != 1)
                MessageBox.Show("更改失败", "错误",
                 MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void button_ModifyBaud_Click(object sender, EventArgs e)
        {
            if (IsInCfg() == 0)
                return;
            if (DTU_ConfigWrite(m_hDTU, "SERBAUD", comboBox_COMBaud.Text) != 1)
                MessageBox.Show("更改失败", "错误",
                 MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

        }

        private void button_ModifyDataB_Click(object sender, EventArgs e)
        {
            if (IsInCfg() == 0)
                return;
            if (DTU_ConfigWrite(m_hDTU, "SERDAT", comboBox_COMDataB.Text) != 1)
                MessageBox.Show("更改失败", "错误",
                 MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

        }

        private void button_ModifyStopB_Click(object sender, EventArgs e)
        {
            if (IsInCfg() == 0)
                return;
            if (DTU_ConfigWrite(m_hDTU, "SERSTP", comboBox_COMStopB.Text) != 1)
                MessageBox.Show("更改失败", "错误",
                 MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

        }

        private void button_ModifyParity_Click(object sender, EventArgs e)
        {
            if (IsInCfg() == 0)
                return;
            if (DTU_ConfigWrite(m_hDTU, "SERCHK",
                System.Convert.ToString(comboBox_COMParity.SelectedIndex)) != 1)
                MessageBox.Show("更改失败", "错误",
                 MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

        }
    }
}
