unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,DTUSet;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    ComboBox_COM: TComboBox;
    Label2: TLabel;
    ComboBox_DataBits: TComboBox;
    Label3: TLabel;
    ComboBox_CheckBits: TComboBox;
    Label4: TLabel;
    ComboBox_Baud: TComboBox;
    Label5: TLabel;
    ComboBox_StopBits: TComboBox;
    Button_EnterCfg: TButton;
    Button_ExitCfg: TButton;
    Button_GetInfo: TButton;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Edit_DevID: TEdit;
    Button_ModifyDevID: TButton;
    Label7: TLabel;
    Edit_Phone: TEdit;
    Button_ModifyPhone: TButton;
    Label8: TLabel;
    Button_ModifyMode: TButton;
    ComboBox_Mode: TComboBox;
    Label9: TLabel;
    ComboBox_COMBaud: TComboBox;
    Button_ModifyCOMBaud: TButton;
    Label10: TLabel;
    ComboBox_COMDataBits: TComboBox;
    Button_ModifyCOMDataBits: TButton;
    Label11: TLabel;
    ComboBox_COMStopBits: TComboBox;
    Button_ModifyCOMStopBits: TButton;
    Label12: TLabel;
    ComboBox_COMCheckBits: TComboBox;
    Button_ModifyCOMCheckBits: TButton;
    Edit1: TEdit;
    Label13: TLabel;
    Edit2: TEdit;
    Label14: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button_EnterCfgClick(Sender: TObject);
    procedure Button_ExitCfgClick(Sender: TObject);
    procedure Button_GetInfoClick(Sender: TObject);
    procedure Button_ModifyDevIDClick(Sender: TObject);
    procedure Button_ModifyPhoneClick(Sender: TObject);
    procedure Button_ModifyModeClick(Sender: TObject);
    procedure Button_ModifyCOMBaudClick(Sender: TObject);
    procedure Button_ModifyCOMDataBitsClick(Sender: TObject);
    procedure Button_ModifyCOMStopBitsClick(Sender: TObject);
    procedure Button_ModifyCOMCheckBitsClick(Sender: TObject);
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    m_hDTU : integer;
    m_bEnterConfig : BYTE;
  published
    procedure SetBtnState(started: BYTE);
    procedure Addcom;
    function IsInCfg(): integer;
    procedure FillInfo(szcmd, szval: PCHAR);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox_COM.ItemIndex:=0;
  ComboBox_DataBits.ItemIndex:=3;
  ComboBox_CheckBits.ItemIndex:=0;
  ComboBox_Baud.ItemIndex:=9;
  ComboBox_StopBits.ItemIndex:= 0;
  ComboBox_Mode.ItemIndex:= 0;
  ComboBox_COMBaud.ItemIndex:= 9;
  ComboBox_COMDataBits.ItemIndex:= 3;
  ComboBox_COMStopBits.ItemIndex:= 0;
  ComboBox_COMCheckBits.ItemIndex:= 0;

  m_hDTU := 0;
  SetBtnState (0);

end;

procedure TForm1.SetBtnState(started: BYTE);
begin
    If started = 0 Then
        Button_EnterCfg.Enabled:= True
    Else
        Button_EnterCfg.Enabled:= False;
    m_bEnterConfig := started;

end;

procedure TForm1.Button_EnterCfgClick(Sender: TObject);
var
res : integer;
begin
    Addcom();
    res:= DTU_Init(m_hDTU);
    if (res=0) or (DTU_EnterConfig(m_hDTU)=0) then
    begin
        DTU_Delete (m_hDTU);
        m_hDTU := 0;
        If res = 0 Then
            ShowMessage ('޷򿪴')
        Else
            ShowMessage ('޷豸');
        Exit;
    end;
    m_bEnterConfig:= 1;
    SetBtnState (m_bEnterConfig);
end;

procedure TForm1.Addcom;
var
comind : integer;
baud : integer;
databits : integer;
checkbits : integer;
stopbits : integer;
begin
    If m_hDTU <> 0 Then
    begin
        DTU_Delete(m_hDTU);
        m_hDTU:= 0;
    end;
    comind := ComboBox_COM.ItemIndex+1;
    baud := StrToInt(ComboBox_Baud.Items[ComboBox_Baud.ItemIndex]);
    databits := StrToInt(ComboBox_DataBits.Items[ComboBox_DataBits.ItemIndex]);
    stopbits := StrToInt(ComboBox_StopBits.Items[ComboBox_StopBits.ItemIndex]);
    {checkbits := StrToInt(ComboBox_CheckBits.Items[ComboBox_CheckBits.ItemIndex]);}
    checkbits := ComboBox_CheckBits.ItemIndex;
    m_hDTU := DTU_AddCOM(comind, baud, databits, checkbits, stopbits);

end;

procedure TForm1.Button_ExitCfgClick(Sender: TObject);
var
predtu : integer;
begin
    predtu := m_hDTU;
    If m_hDTU = 0 Then
        Addcom();

    If (predtu=0) And (DTU_Init(m_hDTU)=0) Then
    begin
        DTU_Delete(m_hDTU);
        m_hDTU := 0;
        ShowMessage('޷豸');
        m_bEnterConfig:=0;
        SetBtnState(m_bEnterConfig);
        Exit;
    end;

    If DTU_ExitConfig(m_hDTU,1)=0 Then
        ShowMessage('ʧ');
    m_bEnterConfig:=0;
    SetBtnState(m_bEnterConfig);
    DTU_Delete(m_hDTU);
    m_hDTU:=0;

end;

procedure TForm1.Button_GetInfoClick(Sender: TObject);
var
szcmd : array[0..20] of CHAR;
szval : array[0..20] of CHAR;
strinfo : AnsiString;
begin
    If IsInCfg()=0 Then
        Exit;
    If DTU_GetAllConfig(m_hDTU)=0 Then
    begin
        ShowMessage('ȡϢʧ');
        Exit;
    end;
    strinfo:='ȡϢ:\r\n\r\n';
    While(DTU_GetConfig(m_hDTU, @szcmd[0], @szval[0])=1) do
    begin
        FillInfo(szcmd, szval);
        strinfo:= strinfo + ':';
        strinfo:= strinfo +szcmd;
        strinfo:= strinfo + '   ֵ:';
        strinfo:= strinfo + szval;
        strinfo:= strinfo +'\r\n';
    end;
    ShowMessage(strinfo);

end;

function TForm1.IsInCfg(): integer;
begin
    If m_bEnterConfig = 0 Then
        ShowMessage('Ƚ״̬');
        
    IsInCfg:=m_bEnterConfig;

end;

procedure TForm1.FillInfo(szcmd,szval : PCHAR);
begin
    If StrComp(szcmd, CMD_DTUID) = 0 Then
        Edit_DevID.Text:= szval
    Else If StrComp(szcmd, CMD_PHON) = 0 Then
        Edit_Phone.Text:= szval
    Else If StrComp(szcmd, CMD_MODE) = 0 Then
        ComboBox_Mode.Text := szval
    Else If StrComp(szcmd, CMD_SERBAUD) = 0 Then
        ComboBox_COMBaud.Text := szval
    Else If StrComp(szcmd, CMD_SERDAT) = 0 Then
        ComboBox_COMDataBits.Text := szval
    Else If StrComp(szcmd, CMD_SERSTP) = 0 Then
        ComboBox_COMStopBits.Text := szval
    Else If StrComp(szcmd, CMD_SERCHK)=0 Then
        ComboBox_COMCheckBits.Text := szval;

end;

procedure TForm1.Button_ModifyDevIDClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=Edit_DevID.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_DTUID, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyPhoneClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=Edit_Phone.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_PHON, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyModeClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_Mode.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_MODE, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMBaudClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMBaud.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERBAUD, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMDataBitsClick(Sender: TObject);
var
strval : AnsiString;
begin
   If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMDataBits.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERDAT, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMStopBitsClick(Sender: TObject);
var
strval : AnsiString;
begin
   If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMStopBits.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERSTP, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMCheckBitsClick(Sender: TObject);
var
strval : AnsiString;
begin
   If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMCheckBits.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERCHK, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.OnClose(Sender: TObject; var Action: TCloseAction);
begin
    If m_bEnterConfig = 1 Then
    begin
        DTU_ExitConfig(m_hDTU, 0);
        DTU_Delete(m_hDTU);
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=Edit1.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SVRIP, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=Edit2.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SVRPORT, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');
end;

end.
